/* Copyright (c) 2000-2002, Jacco Bikker
 * Copyright (c) 2002-2003, Gary Dubuque
 *
 * This file is part of NP+AIML.
 * NP+AIML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 2, or (at your option) any later 
 * version.
 *
 * NP+AIML is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.

 * You should have received a copy of the GNU General Public License along 
 * with NP+AIML; see the file COPYING. If not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

#if !defined(AFX_DUMPDLG_H__3F93B8BA_9940_4DB3_9932_7388AFF0ED3C__INCLUDED_)
#define AFX_DUMPDLG_H__3F93B8BA_9940_4DB3_9932_7388AFF0ED3C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "support.h"

class Core;

// DumpDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CDumpDlg dialog

class CDumpDlg : public CDialog
{
// Construction
public:
	CDumpDlg(CWnd* pParent = NULL);   // standard constructor

	Core *bot;

	void dumpaiml(char *fname,char *fnpat,char *fntmp);

// Dialog Data
	//{{AFX_DATA(CDumpDlg)
	enum { IDD = IDD_DUMP };
	CTreeCtrl	m_aimltree;
	//}}AFX_DATA

	BOOL OnInitDialog();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDumpDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void FillTree();

	int cnt;
	fpos_t fpos[MAX_AIML_FILES];
	fpos_t tpos[MAX_AIML_FILES];
	bool blnUnchecked[MAX_AIML_FILES];


	// Generated message map functions
	//{{AFX_MSG(CDumpDlg)
	virtual void OnOK();
	afx_msg void OnDumpBrowse();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DUMPDLG_H__3F93B8BA_9940_4DB3_9932_7388AFF0ED3C__INCLUDED_)
