// ListDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AIMLpad.h"
#include "ListDlg.h"
#include "TargetDlg.h"
#include "core.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CListDlg dialog


CListDlg::CListDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CListDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CListDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CListDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CListDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


void CListDlg::FillTree()
{
	char *wrk = new char[MAX_BUF_LEN];
	char *buf = new char[MAX_BUF_LEN];
	char *line = new char[MAX_BUF_LEN];
	char *next = new char[MAX_BUF_LEN];
	char *input = CNIL;
	char *patrn = CNIL;
	char *at;
	bool blnInput = false;
	int linenr = 0;
	int iRet = 0;
	long cnt = 0;
	
	intCntTargets = 0;

	CString pkey;
	HTREEITEM hPatrn;
	CString ikey;
	HTREEITEM hInput;
	CTreeCtrl *pTree = (CTreeCtrl*) GetDlgItem(IDC_PATTERNS);
	
	pTree->DeleteAllItems();

	*buf = 0;
	*line = 0;
	FILE *ftargets = fopen(bot->fntar,"r");
	if (ftargets) {
		while (!feof(ftargets)) {
			fgets(next,MAX_LOADSTRING,ftargets);
			cleanspace(next);
			if (strstr(line,"<target>")) intCntTargets++;
			if (strstr(line,"<text>")) {
				while (!strstr(line,"</text>")) {
					if (strlen(line) + strlen(next) > MAX_BUF_LEN) { iRet = linenr; break; }
					strcat(line,next);
					linenr++;
					fgets(next,MAX_BUF_LEN,ftargets);
				}
				if (iRet) break;
				strcpy(buf,at = (strstr(line,"</text>") + 7));
				*at = 0;
				replace(line,"<text>","");
				replace(line,"</text>","");
				if (input != CNIL) delete input;
				newstr(&input,line);
				blnInput = true;
			}
			if (strstr(line,"<pattern>")) {
				while (!strstr(line,"</pattern>")) {
					if (strlen(line) + strlen(next) > MAX_BUF_LEN) { iRet = linenr; break; }
					strcat(line,next);
					linenr++;
					fgets(next,MAX_BUF_LEN,ftargets);
				}
				if (iRet) break;
				strcpy(buf,at = (strstr(line,"</pattern>") + 10));
				*at = 0;
				replace(line,"<pattern>","");
				replace(line,"</pattern>","");
				if (patrn != CNIL) delete patrn;
				newstr(&patrn,line);
				blnInput = false;
			}
			if (strstr(line,"<that>")) {
				while (!strstr(line,"</that>")) {
					if (strlen(line) + strlen(next) > MAX_BUF_LEN) { iRet = linenr; break; }
					strcat(line,next);
					linenr++;
					fgets(next,MAX_BUF_LEN,ftargets);
				}
				if (iRet) break;
				strcpy(buf,at = (strstr(line,"</that>") + 7));
				*at = 0;
				replace(line,"</that>","");
				if (strcmp(line,"<that>") && strcmp(line,"<that>*")) {
					if (blnInput) {
						sprintf(wrk,"%s%s",input,line);
						delete input;
						newstr(&input,wrk);
					} else {
						sprintf(wrk,"%s%s",patrn,line);
						delete patrn;
						newstr(&patrn,wrk);
					}
				}
			}
			if (strstr(line,"<topic>")) {
				while (!strstr(line,"</topic>")) {
					if (strlen(line) + strlen(next) > MAX_BUF_LEN) { iRet = linenr; break; }
					strcat(line,next);
					linenr++;
					fgets(next,MAX_BUF_LEN,ftargets);
				}
				if (iRet) break;
				strcpy(buf,at = (strstr(line,"</topic>") + 8));
				*at = 0;
				replace(line,"</topic>","");
				if (strcmp(line,"<topic>") && strcmp(line,"<topic>*")) {
					if (blnInput) {
						sprintf(wrk,"%s%s",input,line);
						delete input;
						newstr(&input,wrk);
					} else {
						sprintf(wrk,"%s%s",patrn,line);
						delete patrn;
						newstr(&patrn,wrk);
					}
				}
			}
			if (strstr(line,"</target>")) {
				strcpy(buf,at = (strstr(line,"</target>") + 9));
				pkey = patrn;
				hPatrn = pTree->GetRootItem();
				while (hPatrn != NULL) {
					if (pkey == pTree->GetItemText(hPatrn)) break;
					hPatrn = pTree->GetNextItem(hPatrn,TVGN_NEXT);
				}
				if (hPatrn == NULL) hPatrn = pTree->InsertItem(pkey,TVI_ROOT,TVI_SORT);
				ikey = input;
				hInput = pTree->InsertItem(ikey,hPatrn,TVI_SORT);
				cnt++;
				pTree->SetItemData(hInput,cnt);
			}
			strcpy(line,buf);
			strcat(line,next);
		}
		fclose(ftargets);
	}

	delete wrk;
	delete buf;
	delete line;
	delete next;
	UpdateData(false);
}


BOOL CListDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	FillTree();

	return false;
}


BEGIN_MESSAGE_MAP(CListDlg, CDialog)
	//{{AFX_MSG_MAP(CListDlg)
	ON_NOTIFY(NM_DBLCLK, IDC_PATTERNS, OnDblclkPatterns)
	ON_NOTIFY(NM_RCLICK, IDC_PATTERNS, OnRclickPatterns)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListDlg message handlers

void CListDlg::OnDblclkPatterns(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CString m_pattern;
	CTargetDlg *target;

	CTreeCtrl *pTree = (CTreeCtrl*) GetDlgItem(IDC_PATTERNS);
	HTREEITEM hItem = pTree->GetSelectedItem();
	if (hItem != NULL) if(!pTree->ItemHasChildren(hItem)) {
		m_pattern = pTree->GetItemText(hItem);
		target = new CTargetDlg;
		target->bot = bot;
		target->pu = pu;
		target->intAtTarget = pTree->GetItemData(hItem);
		if (target->DoModal() == IDOK) FillTree();
		delete target;
	}

	*pResult = 0;
}

void CListDlg::OnRclickPatterns(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CString str;
	int cnt = 0;
	HTREEITEM nItem;

	CTreeCtrl *pTree = (CTreeCtrl*) GetDlgItem(IDC_PATTERNS);
	HTREEITEM hItem = pTree->GetSelectedItem();
	if (hItem != NULL) if(pTree->ItemHasChildren(hItem)) {
		nItem = pTree->GetChildItem(hItem);
		while (nItem != NULL) {
			cnt++;
			nItem = pTree->GetNextSiblingItem(nItem);
		}
		str.Format(_T("Activations: %d (%d%% of %d targets)"),cnt,(100 * cnt) / intCntTargets, intCntTargets);
		MessageBox(str,_T("Classification statistics"),MB_OK);
	}
	
	*pResult = 0;
}
