#if !defined(AFX_SEARCHDLG_H__B581C69C_F384_4513_B821_85771FAC73AB__INCLUDED_)
#define AFX_SEARCHDLG_H__B581C69C_F384_4513_B821_85771FAC73AB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "support.h"

class Core;

class PUvm;

// SearchDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSearchDlg dialog

class CSearchDlg : public CDialog
{
// Construction
public:
	CSearchDlg(CWnd* pParent = NULL);   // standard constructor

	int intCntCats;
	int cntFiles;
	char *fnames[MAX_AIML_FILES];

	Core *bot;
	PUvm *pu;

// Dialog Data
	//{{AFX_DATA(CSearchDlg)
	enum { IDD = IDD_SEARCH };
	CListCtrl	m_listctrl;
	int		m_SearchType;
	CString	m_SearchText;
	CString	m_SearchThat;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSearchDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	//}}AFX_VIRTUAL

// Implementation
protected:
	void FillForm();
	void FileList();

	fpos_t fpos[MAX_AIML_FILES];
	fpos_t tpos[MAX_AIML_FILES];

	// Generated message map functions
	//{{AFX_MSG(CSearchDlg)
	afx_msg void OnDblclkFoundlist(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnFindCategory();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SEARCHDLG_H__B581C69C_F384_4513_B821_85771FAC73AB__INCLUDED_)
