/* Copyright (c) 2000-2002, Jacco Bikker
 * Copyright (c) 2002-2003, Gary Dubuque
 *
 * This file is part of NP+AIML.
 * NP+AIML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 2, or (at your option) any later 
 * version.
 *
 * NP+AIML is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.

 * You should have received a copy of the GNU General Public License along 
 * with NP+AIML; see the file COPYING. If not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

#if !defined(AFX_CASESDLG_H__2C3080EB_4001_4309_B4EC_5FF1010B3619__INCLUDED_)
#define AFX_CASESDLG_H__2C3080EB_4001_4309_B4EC_5FF1010B3619__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CasesDlg.h : header file
//

class PUvm;

#include "facts.h"

/////////////////////////////////////////////////////////////////////////////
// CCasesDlg dialog

class CCasesDlg : public CDialog
{
// Construction
public:
	CCasesDlg(CWnd* pParent = NULL);   // standard constructor

	PUvm *pu;
	Subjects *kb;

// Dialog Data
	//{{AFX_DATA(CCasesDlg)
	enum { IDD = IDD_CASES };
	CListBox m_cases;
	CString	m_case;
	CString	m_subject;
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCasesDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	//}}AFX_VIRTUAL

// Implementation
protected:
	void FillList();

	// Generated message map functions
	//{{AFX_MSG(CCasesDlg)
	afx_msg void OnMake();
	afx_msg void OnDrop();
	afx_msg void OnDblclkCaselist();
	afx_msg void OnLoadCase();
	afx_msg void OnSaveCase();
	afx_msg void OnLinkFacts();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CASESDLG_H__2C3080EB_4001_4309_B4EC_5FF1010B3619__INCLUDED_)
