/* Copyright (c) 2000-2002, Jacco Bikker
 * Copyright (c) 2002-2003, Gary Dubuque
 *
 * This file is part of NP+AIML.
 * NP+AIML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 2, or (at your option) any later 
 * version.
 *
 * NP+AIML is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.

 * You should have received a copy of the GNU General Public License along 
 * with NP+AIML; see the file COPYING. If not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

#if !defined(AFX_FRAMEDLG_H__5D9ED384_E376_451E_9A2E_B320F0D956D3__INCLUDED_)
#define AFX_FRAMEDLG_H__5D9ED384_E376_451E_9A2E_B320F0D956D3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "scripts.h"

// FrameDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CFrameDlg dialog

class CFrameDlg : public CDialog
{
// Construction
public:
	CFrameDlg(CWnd* pParent = NULL);   // standard constructor

	Scripts *pgm;
	CString m_name;
	bool m_modified;

// Dialog Data
	//{{AFX_DATA(CFrameDlg)
	enum { IDD = IDD_FRAME };
	CString	m_frameid;
	CString	m_script;
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFrameDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CFrameDlg)
	afx_msg void OnFind();
	afx_msg void OnSave();
	afx_msg void OnChangeScript();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FRAMEDLG_H__5D9ED384_E376_451E_9A2E_B320F0D956D3__INCLUDED_)
