/* Copyright (c) 2000-2002, Jacco Bikker
 * Copyright (c) 2002-2003, Gary Dubuque
 *
 * This file is part of NP+AIML.
 * NP+AIML is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by the 
 * Free Software Foundation; either version 2, or (at your option) any later 
 * version.
 *
 * NP+AIML is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.

 * You should have received a copy of the GNU General Public License along 
 * with NP+AIML; see the file COPYING. If not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

#if !defined(AFX_SUBJECTSDLG_H__F773D3D6_7BD5_4301_A02A_268000C6963F__INCLUDED_)
#define AFX_SUBJECTSDLG_H__F773D3D6_7BD5_4301_A02A_268000C6963F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class PUvm;

#include "facts.h"

// SubjectsDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSubjectsDlg dialog

class CSubjectsDlg : public CDialog
{
// Construction
public:
	CSubjectsDlg(CWnd* pParent = NULL);   // standard constructor

	PUvm *pu;
	Subjects *kb;

// Dialog Data
	//{{AFX_DATA(CSubjectsDlg)
	enum { IDD = IDD_SUBJECTS };
	CListBox m_subjects;
	CString  m_subject;
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSubjectsDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	//}}AFX_VIRTUAL

// Implementation
protected:
	void FillList();

	// Generated message map functions
	//{{AFX_MSG(CSubjectsDlg)
	afx_msg void OnConsider();
	afx_msg void OnDiscard();
	afx_msg void OnDblclkSubjectlist();
	afx_msg void OnGetSubject();
	afx_msg void OnPutSubject();
	afx_msg void OnLinkCases();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SUBJECTSDLG_H__F773D3D6_7BD5_4301_A02A_268000C6963F__INCLUDED_)
